﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApplication3
{
    public partial class Form1 : Form
    {
        private Graphics g;
        private bool paintOnpaint = false;

        public Form1()
        {
            InitializeComponent();
            g = pictureBox1.CreateGraphics();
        }

        private void DrawWithGraphics()
        {
            for (int i = 0; i < 100; i++)
            {
                for (int j = 0; j < 100; j++)
                {
                    int x = i * 5;
                    int y = j * 5;

                    g.DrawRectangle(Pens.Black, new Rectangle(x, y, 5, 5));
                }
            }

            g.Dispose();
        }

        private void DrawWithOutGraphics(PaintEventArgs e)
        {

            for (int i = 0; i < 100; i++)
            {
                for (int j = 0; j < 100; j++)
                {
                    int x = i * 5;
                    int y = j * 5;

                    e.Graphics.DrawRectangle(Pens.Black, new Rectangle(x, y, 5, 5));
                }
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            DrawWithGraphics();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            paintOnpaint = true;
            pictureBox1.Invalidate();
        }

        private void pictureBox1_Paint(object sender, PaintEventArgs e)
        {
            if (paintOnpaint)
                DrawWithOutGraphics(e);
        }
    }
}
